"use strict";
this.name 			= "asp-feudal-shipset";
this.author 		= "Rustem";
this.copyright 		= "2017";
this.description	= "Ship script for feudal ship from feudal system";
this.licence     	= "CC BY-NC-SA 4.0";
this.version 		= "0.6";

// ! :  No addition to GC MostWanted list.

this.logging = true;      // false/true
this.debug_AI = false;    // logging setAI
this.debug_Bty = false;   // logging setBounty
this.debug_Wpn = false;   // logging setWeapon
this.debug_Eqp = false;   // logging setEquipment

this.shipSpawned = function (shipKey) {
	var s = this.ship;
	var k = s.dataKey;
	var pr = s.primaryRole;
	var sc = s.script;

	var w = worldScripts.Assassin_shipset_pack;
	if (w) {
		// Setting role : check at array of default roles
		pr = w._setPrimaryRoleToShip(s);
		//mw_chance = 1; // always added to GC MW list for test

		// Setting bounty : check current bounty for role and set a hiddenBounty
		if (pr && !sc.hasOwnProperty("_hiddenBounty")) {
			if (this.debug_Bty) log(this.name + " : " + pr);

			// Check bounty and AI for primaryRole based on the oolite-populator rules // TODO: check ship.autoAI
			w._setBountyToShip(s);
		}
	}

	// WIP: Check autoWeapons rules
	if (!s.autoWeapons && pr.indexOf('raider') > -1) { // raiders need the best equipment
		s.awardEquipment("EQ_FUEL_INJECTION");
		s.awardEquipment("EQ_SHIELD_BOOSTER");
		s.awardEquipment("EQ_ECM");
		s.fuel = 7;
		if (this.debug_Eqp) log("Assassin_shipset_pack", this.name + " : award raider the best equipment: " + s.displayName + " [" + k + "]");
	}

	delete this.shipSpawned;
}

this.shipLaunchedEscapePod = function (escapepod, passengers) {
	if (escapepod) {
		var pod = escapepod; // var ws = worldScripts.BountySystem_Core;
		// add for pirate only
		if (this._hiddenBounty) { // $initBounty
			this.$assassinEscapePod = true;
			// edit the pilot legalStatus // ALTERNATIVE: may be solved via oolite-character
			var pilotBounty = pod.crew[0].legalStatus + this._hiddenBounty; // $initBounty
			// set the seed values so that the pilot's species can be defined by their home system
			// var seed = "0 0 0 0 "+ pod.crew[0].homeSystem.toString() +" 2"; // WAIT: ?
			var seed = "0 0 0 0 0 0";
			pod.setCrew({
				name: pod.crew[0].name,
				origin: pod.crew[0].homeSystem,
				insurance: pod.crew[0].insuranceCredits,
				bounty: pilotBounty,
				short_description: pod.crew[0].description,
				random_seed: seed
			});
			// , random_seed:seed / , species:pod.crew[0].species
			this._hiddenBounty = null; // $initBounty

			if (this.debug_Bty) log("Assassin_shipset_pack", this.name + " : added the hiddenBounty to crew legalStatus of the pod");
		}
		//if (this.ship.bounty) this.ship.bounty = null; // WAIT: Need or edited this.shipDied? The oolite-core don't processed.
		if (this.logging) log("Assassin_shipset_pack", this.name + " : derelicted " + this.ship.name + "(" + this.ship.primaryRole + ") apply ePod: " + pod.name + ", passengers: " + passengers);
	}
}

this.shipDied = function (whom, cause) {
	// check bounty 	// 250 /750 /2250 from shipdata feudal_...AP_shipset
	// If pod.crew[0].legalStatus will writen status then should fixed checking bounty mechanic.
	var bounty;
	if (this.$assassinEscapePod || this.ship.bounty && this._hiddenBounty) { // this.ship.bounty && this.$initBounty ... && !this.ship.isDerelict
		bounty = this._hiddenBounty; // $initBounty
		if (whom && whom.isPlayer && !player.ship.isCloaked) {
			player.credits += bounty;
			// TODO: Add delay consoleMessage
			player.consoleMessage("Bonus: " + formatCredits(bounty, true, true), 8);
			player.consoleMessage("Total: " + formatCredits(player.credits, true, true), 10);
			if (this.debug_Bty) log("Assassin_shipset_pack", this.name + " : " + bounty + " Cr. of the hiddenBounty added to player credits");
		}
	} else if (this.debug_Bty) log("Assassin_shipset_pack", this.name + " : bounty: " + this.ship.bounty + ", hiddenBounty: " + this._hiddenBounty);

	if (this.logging) {
		log("Assassin_shipset_pack", this.name + " : died(orig) " + this.ship.name + " (" + this.ship.primaryRole + "), " + this.ship.displayName + " [" + this.ship.dataKey + "]");
		log("Assassin_shipset_pack", this.name + " : " + this.ship.name + " was killed by " + whom + " because of " + cause);
	}

	delete this.shipDied;
}
