"use strict";
this.name 			= "asp-tech-shipset";
this.author 		= "Rustem";
this.copyright 		= "2017";
this.description	= "Ship script for stealth ship from higher tech-level worlds";
this.licence     	= "CC BY-NC-SA 4.0";
this.version 		= "0.7.6";

// !!! : this script not will set some var for escort, fighter and freighter roles

// Addition to GC MostWanted list delevoped for assassin role. Current GC MostWanted v0.5.

// TODO: How do a clearing bounty for hunter (AIScript) in the thargoid-counter / friendly fire

this.logging = false;       // false/true
this.debug_AI = false;     // logging setAI
this.debug_Bty = false;    // logging setBounty
this.debug_Wpn = false;    // logging setWeapon
this.debug_Eqp = false;    // logging setEquipment

this.$setWeapons = true; // true - a tunning of the weapons. Also it is setted from worldscript blacklist.
// If New lasers OXP is not installed, then attempted setup default laser(P,B,M), otherwise get a heavy-weapon assassin in the gameplay (seen shipdata.plist).

this.shipSpawned = function (shipKey) {
	var s = this.ship;
	var k = s.dataKey;
	var pr = s.primaryRole;
	var sc = s.script;

	var w = worldScripts.Assassin_shipset_pack;

	if (k.indexOf("stealth") > -1) {
		w._setStealthToShip(s)
		if (this.logging) log("Assassin_shipset_pack", this.name + " : set a stealth features");
	}

	// WIP: Deny rule : for BountySystem_MostWanted
	var mostWanted = true;
	var mw = worldScripts.BountySystem_MostWanted;
	if (w && mw) {
		var index = sc._mostWanted; // leader & escorts
		if (index) {
			// allow spawn escort - version 2, other version locate in spawnArmouryAssassins
			//w._mw_escorts = true; log("assassin_shipset_pack", "! allow spawn mw-escorts"); // allow after leader

			s.bounty = 0; // if (s.primaryRole.indexOf("pirate") < 0) s.bounty = 0;
			// escort has non-default role name
			if (pr.indexOf(k) > -1) { // special set for escort
				if (s.group && s.group.leader && s.group.leader.AIScript.name.indexOf("Oolite Assassin") > -1) {
					s.switchAI("oolite-assassinAI.js");
					if (this.logging) log("Assassin_shipset_pack", this.name + " : set assassinAI for escort");
				}
				s.setBounty(s.bounty, "setup actions");
				w._awardWeaponEquipments(s)
			}
			// delete logging after testing
			if (this.logging) log("Assassin_shipset_pack", this.name + " - Amount: " + w._wanted_amount + ", spawn count: " + w._mw_count + ". This " + pr + "[" + k + "] has MW index: " + index + " --> deny a standart set AI, bounty, weapons");
			w._delayedCheckPendingList(w._mw_count); // TEST: a wait for constant use
			w._mw_count--;
			delete this.shipSpawned;
			return;
		}
		if (w._mw_count > 0) { // bountyVersionExists(k) // other solution: check ship.script._mostWanted ~ wanted.index
			// delete logging after testing
			if (this.logging) log("Assassin_shipset_pack", this.name + " - Amount: " + w._wanted_amount + ", spawn count: " + w._mw_count + ". This " + pr + "[" + k + "] in the MW pending list --> deny a standart set AI, bounty, weapons");
			w._delayedCheckPendingList(w._mw_count); // TEST: a wait for constant use
			w._mw_count--;
			delete this.shipSpawned;
			return;
		} else mostWanted = false;
	}

	// WIP: Calculate chance and set a chance for group leader.
	var chance = Math.random();
	var mw_chance = 0.7; // TODO: add secondary rule : for example, check _wanted.length < max_limit, distance to player
	var lead = s;
	var wg_name = "one_pilot";
	var g = s.group;
	if (g) {
		if (g.leader) lead = g.leader;
		if (g.leader && s.entityPersonality === g.leader.entityPersonality) {
			chance *= 0.428;
			mw_chance += 0.27;
		}
		if (!g.name) {
			wg_name = "wanted_pack_group_" + w._wanted_amount;
		} else {
			wg_name = g.name + " " + w._wanted_amount;
		}
	}

	// Setting a primaryRole, bounty, AI, weapons
	if (w) {
		// Check at array of default roles
		pr = w._setPrimaryRoleToShip(s);
		//mw_chance = 1; // always added to GC MW list for test

		// Check current bounty for role and set a hiddenBounty
		if (pr && !sc.hasOwnProperty("_hiddenBounty")) {
			if (this.debug_Bty) log(this.name + " : " + pr);

			// Check bounty and AI for primaryRole based on the oolite-populator rules // TODO: check ship.autoAI
			w._setBountyToShip(s);
		}
		// Set lasers and extra missiles
		if ($setWeapons) {
			w._setWeaponsToShip(s, chance, this.debug_Wpn);
		} else log("Assassin_shipset_pack", this.name + " : Check var: autoWeapons, $setWeapons, roles to set lasers for " + ship.name + "!!!");

		// Setting a equipments : award with chance 
		// all roles: shield booster, shield enhancer, military jammer and cloaking device
		// raiders role need the best equipment: fuel injection, ecm, shield booster
		w._setEquipments(s, chance);
	}

	// TEMP: Cut the role name : temp for beta-testing. Role identification will deleted before final release.
	if (s.displayName.indexOf('(') > -1 && s.displayName.indexOf(')') > -1) { // displayName | name
		var name = s.displayName.split(' ('); // var sname = name[1].split(': ');
		s.displayName = name[0]; //+": "+sname[1];
	}

	// WIP: Checking rule for addition this ship to GC MostWanted list : only assassin
	if (!mostWanted && (pr.indexOf('assassin') > -1)) { // WAIT: may be in next version will expanded roles
		// TEST: need modify secondary rule // !mw.$bountyVersionExists(k)
		if (w._wanted_amount < 5) {
			if (this.logging) log("Assassin_shipset_pack", this.name + " : " + mw_chance + " chance " + s.name + " add to MostWanted list");
			if (Math.random() < mw_chance) {
				if (s === lead) { // WAIT REPEAT OF ERROR: not lead will added to MostWanted list?
					var wg_name;
					w._leader = lead;
					w._groupName = wg_name;
					//if (this.logging)
					log("Assassin_shipset_pack", this.name + " : adding " + s.name + " [" + wg_name + "] to MostWanted list, count: " + w._wanted_amount);
					// creates new records of ship and pilot data
					w._delayedAddMostWanted(s);
				} else log("Assassin_shipset_pack", this.name + " : this ship is not leader for addition in MW list for pack: " + s);
			}
		} else log("Assassin_shipset_pack", this.name + " : Overlimited an amount ship in MW list for pack");
	}

	delete this.shipSpawned;
}

this.shipLaunchedEscapePod = function (escapepod, passengers) {
	if (this.$stealthMode) this.$stealthMode("off"); //test

	if (escapepod) {
		var pod = escapepod; // var ws = worldScripts.BountySystem_Core;
		// add for pirate only
		if (this._hiddenBounty) {
			this.$assassinEscapePod = true;
			// edit the pilot legalStatus // ALTERNATIVE: may be solved via oolite-character
			var pilotBounty = pod.crew[0].legalStatus + this._hiddenBounty;
			// set the seed values so that the pilot's species can be defined by their home system
			// var seed = "0 0 0 0 "+ pod.crew[0].homeSystem.toString() +" 2"; // WAIT: ?
			var seed = "0 0 0 0 0 0";
			pod.setCrew({
				name: pod.crew[0].name,
				origin: pod.crew[0].homeSystem,
				insurance: pod.crew[0].insuranceCredits,
				bounty: pilotBounty,
				short_description: pod.crew[0].description,
				random_seed: seed
			});
			// , random_seed:seed / , species:pod.crew[0].species
			this._hiddenBounty = null;

			if (this.debug_Bty) log("Assassin_shipset_pack", this.name + " : added the hiddenBounty to crew legalStatus of the pod");
		}
		//if (this.ship.bounty) this.ship.bounty = null; // WAIT: Need or edited this.shipDied? The oolite-core don't processed.		
		if (this.logging) {
			log("Assassin_shipset_pack", this.name + " : derelicted(orig) " + this.ship.name + " (" + this.ship.primaryRole + "), " + this.ship.displayName + " [" + this.ship.dataKey + "]");
			log("Assassin_shipset_pack", this.name + " : personality " + this.ship.entityPersonality + " apply ePod: " + pod.name + ", passengers: " + passengers);
		}
	}
}

this.shipDied = function (whom, cause) // copy and merge from main script deep_stealth_raiders
{
	// check bounty 	// 500 /1500 /4500 from shipdata stealth_...AP_shipset
	// If pod.crew[0].legalStatus will writen status then should fixed checking bounty mechanic.
	var bounty;
	if (this.$assassinEscapePod || this.ship.bounty && this._hiddenBounty) { // this.ship.bounty && this.$initBounty ... && !this.ship.isDerelict
		bounty = this._hiddenBounty;
		if (whom && whom.isPlayer && !player.ship.isCloaked) {
			player.credits += bounty;
			// TODO: Add delay consoleMessage
			player.consoleMessage("Bonus: " + formatCredits(bounty, true, true), 8);
			player.consoleMessage("Total: " + formatCredits(player.credits, true, true), 10);
			if (this.debug_Bty) log("Assassin_shipset_pack", this.name + " : " + bounty + " Cr. of the hiddenBounty added to player credits");
		}
	} else if (this.debug_Bty) log("Assassin_shipset_pack", this.name + " : bounty: " + this.ship.bounty + ", hiddenBounty: " + this._hiddenBounty);

	if (this.logging) {
		log("Assassin_shipset_pack", this.name + " : died(orig) " + this.ship.name + " (" + this.ship.primaryRole + "), " + this.ship.displayName + " [" + this.ship.dataKey + "]");
		log("Assassin_shipset_pack", this.name + " : personality " + this.ship.entityPersonality + " was killed by " + whom + " because of " + cause);
	}

	delete this.shipDied;
}
