"use strict";
this.name 			= "spawnFeudalAssassins";
this.author 		= "spara & rustem & Stranger";
this.copyright 		= "2017 Creative Commons: attribution, non-commercial, sharealike."; // CC BY-NC-SA 4.0
this.description	= "Conditional spawning of assassins from Feudal system";
this.version 		= "0.3";

// This is modification of spara's rh-boss-spawn-shipset script

this.logging = false; // false / true

this.allowSpawnShip = function (shipKey) {
	// System validator
	if (system.isInterstellarSpace || !system.sun || system.sun.isGoingNova || system.sun.hasGoneNova)
		return false;
	
	// Check worldScripts
	var ws = worldScripts.Assassin_shipset_pack,
		ht = worldScripts.GalCopBB_HitTeams;
	if (ht && ws._ht_ships && ws._ht_ships.length > 0) { // ws._ht_amount > 0
		var k = shipKey;
		for (var i = 0; i < ws._ht_ships.length; i++) {
			if (k === ws._ht_ships[i]) {
				ws._ht_ships.splice(i, 1); //ws._ht_amount--; // log("assassin_shipset_pack", "spawn feudal ht-ship");
				return true;
			}
		}
	}

	var adjacent, homeSystem, homeRichSystem;

	// Feudal system (G1..3, 5..8), that's where feudal assassins primarily lurk (only hunter). // Total systems : 32
	if (system.government == 1) {
		if (shipKey.indexOf('feudal_') > -1) { // hunter & pirate
			if (this.logging) {
				log("assassin_shipset_pack", "Spawning in Feudal system: " + shipKey + " from this system");
			}
			return true; // true --> false // need design AI //edit rustem
		} // add rustem
		else { // add rustem
			if (system.economy < 4) return false; // add rustem
		} // add rustem
	} // } //add rustem

	// Nearby feudal systems scan.
	var adjacentSystems = system.info.systemsInRange(7);
	var raidBase = 0; // Feudal systems in 7 LY proximity
	var richBase = 0; // Rich feudal systems in 7 LY proximi
	for (var i = 0; i < adjacentSystems.length; i++) {
		adjacent = System.infoForSystem(adjacentSystems[i].galaxyID, adjacentSystems[i].systemID);
		if (adjacent.government == 1) { // Total : 32
			raidBase += 1;
			homeSystem = adjacent;
			if (adjacent.economy < 4) { // Total Ind (ind raidBase) : ~ 16 [8..22]
				richBase += 1;
				homeRichSystem = adjacent;
			}
		}
	}

	// Feudal system(s) next door. 	1 ind raidBase & other gov --> populate only hunters.
	// Sometimes feudal hunters visit nearby systems. Poor the economy, frequent the incident.
	if (Math.random() * (7 - system.economy) < richBase) {
		if (shipKey.indexOf('feudal_') > -1 && shipKey.indexOf('_AP_shipset') > -1) { // pirate
			return false;
		}
		// TODO: homeSystem, consoleMessage and etc.
		if (homeRichSystem != undefined) {
			homeSystem = homeRichSystem;
		}
		if (this.logging) {
			log("assassin_shipset_pack", "Spawning in nearby poor-system: " + shipKey + " from " + homeSystem.systemID + ", raidBase=" + raidBase + ", richBase=" + richBase);
		}
		return true; // hunter
	}

	// Feudal system(s) next door. 	1 ind raidBase & other gov --> populate only hunters.
	// Sometimes feudal raiders visit nearby systems. Higher the government, rarer the incident.
	if (Math.random() * system.government < raidBase) {
		if (raidBase == richBase && (shipKey.indexOf('feudal_') > -1 && shipKey.indexOf('Hunter_AP_shipset') > -1)) { // hunter & hunters escort
			return false;
		}
		// TODO: homeSystem, consoleMessage and etc.
		if (homeRichSystem != undefined) {
			homeSystem = homeRichSystem;
		}
		if (this.logging) {
			log("assassin_shipset_pack", "Spawning in nearby risk-system: " + shipKey + " from " + homeSystem.systemID + ", raidBase=" + raidBase + ", richBase=" + richBase);
		}
		return true; // hunter & pirate
	}

	return false;
}
