"use strict";
this.name 			= "spawnAnarchyAssassins";
this.author 		= "spara & rustem";
this.copyright 		= "2017 Creative Commons: attribution, non-commercial, sharealike."; // CC BY-NC-SA 4.0
this.description	= "Conditional spawning of assassins from Anarchy system";
this.version 		= "0.3";

// This is modification of spara's rh-boss-spawn-shipset script

this.logging = false; // false / true

this.allowSpawnShip = function (shipKey) {
	// Sanity check
	if (system.isInterstellarSpace || !system.sun || system.sun.isGoingNova || system.sun.hasGoneNova)
		return false;

	// Check worldScripts
	var ws = worldScripts.Assassin_shipset_pack,
		ht = worldScripts.GalCopBB_HitTeams;
	if (ht && ws._ht_ships && ws._ht_ships.length > 0) { // ws._ht_amount > 0
		var k = shipKey;
		for (var i = 0; i < ws._ht_ships.length; i++) {
			if (k === ws._ht_ships[i]) {
				ws._ht_ships.splice(i, 1); //ws._ht_amount--; // log("assassin_shipset_pack", "spawn anarchy ht-ship");
				return true;
			}
		}
	}

	var adjacent, homeSystem; // var shipKey = dataKey;

	// An anarchy system (G1..8), that's where the assassins primarily lurk. // Total systems : 32 (max: 64 in Galaxy 4)
	// economy: 0 (Rich Industrial) ... 7 (Poor Agricultural)

	//if (system.government === 0) {
	if (system.government === 0 && system.economy < 4) { // RandomHit_tweak: SpaceBar -> Total Ind : ~ 18,5 (16..32)
		if (this.logging) {
			homeSystem = system;
			log("assassin_shipset_pack", "Spawning in Anarchy system: " + shipKey + " from this system");
		}
		return true;
	}
	// Ok, not an anarchy system, but maybe there is such a system close by.
	var adjacentSystems = system.info.systemsInRange(7);
	var dangerousHood = false;
	for (var i = 0; i < adjacentSystems.length; i++) {
		adjacent = System.infoForSystem(adjacentSystems[i].galaxyID, adjacentSystems[i].systemID);
		if (adjacent.government === 0 && adjacent.economy < 4) { // RandomHit_tweak: SpaceBar
			dangerousHood = true;
			homeSystem = adjacent;
			log("assassin_shipset_pack", "Found nearby dangerous homeSystem");
			break;
		}
	}

	// This is dangerous hood, there is an anarchy system next door.
	// Sometimes bosses visit nearby systems. Higher the government, rarer the incident.
	if (dangerousHood && Math.random() * system.government < 0.5) { // 0.5/1.0
		// TODO: homeSystem, consoleMessage and etc.
		//if (homeSystem === undefined) { homeSystem = system; }
		if (this.logging) {
			log("assassin_shipset_pack", "Spawning in Anarchy zone: " + shipKey + " from " + homeSystem.systemID);
		}
		return true;
	}
	return false;
}
