"use strict";
this.name 			= "spawnArmouryAssassins";
this.author 		= "spara & rustem";
this.copyright 		= "2017 Creative Commons: attribution, non-commercial, sharealike."; // CC BY-NC-SA 4.0
this.description	= "Conditional spawning of armoury-assassins from high tech system";
this.version 		= "0.8";

// This is modification of spara's rh-boss-spawn-shipset script

// Addition to GC MostWanted list delevoped for assassin role. Current GC MostWanted v0.12.

this.logging = false; // false / true

// government:	0 (Anarchy) to 7 (Corporate State)
this.govTypes = [
	"Anarchy",
	"Feudal",
	"Multi-Government",
	"Dictatorship",
	"Communist",
	"Confederacy",
	"Democracy",
	"Corporate State"
];
// techlevel: 	0 to 15
// economy: 	0 (Rich Industrial) ... 7 (Poor Agricultural)

this.allowSpawnShip = function (shipKey) {
	// Sanity check
	if (!system.sun || system.sun.isGoingNova || system.sun.hasGoneNova) {
		if (!system.isInterstellarSpace)
			return false;
	}

	// Check worldScripts
	var ws = worldScripts.Assassin_shipset_pack,
		mw = worldScripts.BountySystem_MostWanted,
		ht = worldScripts.GalCopBB_HitTeams;
	if (mw) {
		var c, k = shipKey;
		c = system.countShipsWithRole("[" + k + "]");
		if (mw._pending.length > 0) { // WAIT: mw.$bountyVersionExists(shipKey) / Ship.shipDataForKey("bounty_stealth_Assassin_AP_shipset")
			for (var i = 0; i < mw._pending.length; i++) {
				if (k === mw._pending[i].shipKey) { // JSON.parse(mw._pending[i].data).shipDataKey
					ws._mw_count++; // TEST: Sometime may be errors, so two times is checked this condition script by populator.
					ws._mw_escorts = true;
					log("assassin_shipset_pack", "! allow spawn mw-escorts"); // allow after leader
					if (this.logging) {
						if (c > 0) {
							log("assassin_shipset_pack", "!! (in-system): " + ws._mw_count + " count for spawn a mw-ship: " + k + ", current shipKey count:" + c);
						} else {
							log("assassin_shipset_pack", "! (in-system): " + ws._mw_count + " count for spawn a new mw-ship: " + k);
						}
					}
					return true;
				}
			}
			if (ws._mw_escorts) {
				ws._mw_count++;
				log("assassin_shipset_pack", "! (in-system): " + ws._mw_count + " count for spawn a mw-escort: " + k);
				return true;
			}
		}
	}
	// Check GalCopBB_HitTeams
	if (ht && ws._ht_ships && ws._ht_ships.length > 0) { // ws._ht_amount > 0
		var k = shipKey;
		for (var i = 0; i < ws._ht_ships.length; i++) {
			if (k === ws._ht_ships[i]) {
				ws._ht_ships.splice(i, 1); //ws._ht_amount--; // log("assassin_shipset_pack", "spawn armoury ht-ship");
				return true;
			}
		}
	}
	ws = worldScripts.Thargoids_Warfare; // test oxp
	if (ws) {
		if (ws.invasionExtantInCurrentSystem) return true;
	}

	var adjacent, homeSystem; //var shipKey = dataKey; // gov, tech

	// WAIT: need correct system.info mechanics // 9+Math.random()*6 < system.info.techlevel || Math.random() * (15 - system.info.techlevel) < 0.5

	// An anarchy system, that's where the armoury primarily lurk.
	//if (system.government === 0) { // test work version

	// WAIT: An tech/risk system, that's where the armoury possibly lurk. // Total systems : ~ 45 (48+40+42+44+47+52+43+43)
	if (system.government < 5 && system.economy < 4 && 8 + Math.random() * 7 < system.info.techlevel) { // system.government < 5 || system.techlevel  > 8/12
		//if (system.government < 5 && system.economy < 4 && 9+Math.random()*6 < system.info.techlevel) { // Total systems :
		// TODO: homeSystem, consoleMessage and etc.
		homeSystem = system.info; // if (homeSystem === undefined) { homeSystem = system.info; };
		if (this.logging) {
			log("assassin_shipset_pack", "Spawning of armoury in tech/risk system: " + shipKey + " from " + homeSystem.systemID + " (" + this.govTypes[homeSystem.government] + " [TL:" + homeSystem.techlevel + "])");
		}
		return true; // armoury (hunter & pirate)
	}

	// WAIT: need correct system.info mechanics

	// Ok, not an tech/risk system, but maybe there is high tech (or Multi-Government[2], Dictatorship[3], Communist[4]) system close by.
	// That's where armoury primarily lurk.
	var adjacentSystems = system.info.systemsInRange(7);
	var dangerousHood = false;
	for (var i = 0; i < adjacentSystems.length; i++) {
		adjacent = System.infoForSystem(adjacentSystems[i].galaxyID, adjacentSystems[i].systemID); // gov = parseInt(adjacent.government); tech = parseInt(adjacent.techlevel);
		//if (adjacent.government === 0) // test work version
		// WAIT:
		//if (adjacent.techlevel > 9 && adjacent.government > 1 && adjacent.government < 5) // Total systems :
		if (adjacent.techlevel > 8 && adjacent.government > 1 && adjacent.government < 5) // Total systems : ~ 37 (40+33+32+40+41+39+35+34)
		{
			dangerousHood = true;
			homeSystem = adjacent; // log("assassin_shipset_pack", "Found nearby tech/risk homeSystem ("+this.govTypes[homeSystem.government]+" [TL:"+homeSystem.techlevel+"])");
			break;
		}
	}

	// This is dangerous hood, there is an interstellar or anarchy system next door.
	if (dangerousHood) {
		// 1 rule: addition in the interstellar space ~ (interstellar hunters), stats: [100]		
		if (system.isInterstellarSpace) {
			if (this.logging) {
				log("assassin_shipset_pack", "Spawning of armoury in the interstellar space.");
			}
			return true; // armoury (hunter & pirate)
		// 2 rule: Sometimes armoury visit nearby systems. Higher the government, rarer the incident.
		} else if (Math.random() * system.government < 0.5) { //0.5/1.0
			// TODO: homeSystem, consoleMessage and etc.
			if (this.logging) {
				log("assassin_shipset_pack", "Spawning of armoury in nearby system: " + shipKey + " from " + homeSystem.systemID + " (" + this.govTypes[homeSystem.government] + " [TL:" + homeSystem.techlevel + "])");
			}
			return true; // armoury (hunter & pirate)
		}
	}
	return false;
}
